config/routes.rb
Orders::Engine.routes.draw do
  resources :orders, path: '/'
  get '/item/details/:id', to: 'details#show', as: 'product_details'
end

app/models/order.rb
#
# An Order record represents a single invoice.
#
class Order < ApplicationRecord
  #include Wisper::Publisher
  include Order::Creation

  has_code length: 6, type: :alphanum

  store :data, coder: JSON
  enum :state, [:new, :paid, :pending, :error, :canceled, :refunded], prefix: true # payment state

  belongs_to :member, optional: true
  belongs_to :shipment, optional: true
  has_many :order_lines, -> { includes(:product_type) }, inverse_of: 'order', dependent: :destroy
  has_one :shipping_label, dependent: :destroy

  has_many :products, through: :order_lines
  has_many :product_types, through: :order_lines

  has_many :transactions, dependent: :nullify

  monetize :amount_cents,   with_model_currency: :currency, numericality: true, allow_nil: true
  monetize :value_cents,    with_model_currency: :currency, numericality: true, allow_nil: true
  monetize :tax_cents,      with_model_currency: :currency, numericality: true, allow_nil: true
  monetize :total_cents,    with_model_currency: :currency, numericality: true, allow_nil: true

  def shippable_to
    product_types.map(&:shippable_to).compact.reduce(&:intersection)
  end

  def is_paid?
    self.state_paid?
  end

  def update_totals!
    self.is_shipping_required = false
    self.is_assignment_required = false
    self.amount_cents = 0
    self.value_cents  = 0
    self.tax_cents    = 0
    missing_assignments = []

    order_lines.each do |ol|
      self.amount_cents += ol.amount_cents || 0
      self.value_cents  += ol.value_cents || 0
      self.tax_cents    += ol.tax_cents || 0
      self.is_shipping_required   ||= ol.is_shipping_required?
      self.is_assignment_required ||= ol.is_assignment_required?
      if ol.is_assignment_required? && !ol.has_assignment?
        missing_assignments << ol
      end
    end

    self.total_cents = self.tax_cents + self.amount_cents

    if self.is_assignment_required? && missing_assignments.empty?
      self.has_assignment = true
    end

    self.save!
  end

  def finalize_payment(customer)
    raise ArgumentError if !persisted? || total_cents.nil?
    payment = Transaction::CardPayment.attempt_payment(
      amount_cents: total_cents, currency: currency,
      customer: customer, member: member, order: self,
      record_matching_debit: true
    )
    if payment.state_success?
      self.update(state: "paid")
    else
      self.update(state: "error")
    end
  end

end

app/models/order/creation.rb
module Order::Creation
  extend ActiveSupport::Concern

  included do
    attr_accessor :order_lines_changed
  end

  def add_line(item_definition_hash)
    create_order_lines(item_definition_hash).map do |ol|
      order_lines.append(ol)
      if ol.persisted?
        self.order_lines_changed = true
      else
        self.errors.add(:base, "Order line items not saved")
      end
      ol
    end
  end

  def add_lines(line_definitions)
    if line_definitions
      if line_definitions.is_a?(Hash)
        line_definitions = line_definitions.values # ignore keys
      end
      raise ArgumentError unless line_definitions.is_a?(Array)
      line_definitions&.each do |line|
        add_line(line)
      end
    end
  end

  class_methods do
    #
    # Central entrypoint for all order creation. No order
    # should be created except for with this method.
    #
    def creator(**args)
      args.stringify_keys!
      order = nil
      Order.transaction do
        lines = args.delete('lines')
        order = Order.create(**args)
        if order.persisted?
          order.add_lines(lines)
          yield order if block_given?

          order.update_totals! if order.order_lines_changed
          #order.send(:publish, :order_created, order)
        end
      end
      return order
    end
  end

  private

  #
  # A single line definition might create multiple order lines
  #
  def create_order_lines(line_definition)
    return [OrderLine.creator('order' => self, **line_definition)].flatten
  end

end

app/controllers/admin/orders/orders_controller.rb
class Admin::Orders::OrdersController < AdminApp::ApplicationController
  helper Orders::Engine.helpers

  before_action :fetch_order, only: [:show, :edit, :update, :destroy]

  def index
    @orders = Order.order(created_at: :desc).includes(:member).page(params[:page])
    if params[:view]
      @orders = @orders.where(state: params[:view])
    end
  end

  def show
  end

  def edit

  end

  def update

  end

  def destroy
    if @order.transactions.empty?
      @order.destroy
      redirect_to(params[:return_url] || orders_path)
    end
  end

  private

  def fetch_order
    @order = Order.from_param(params[:id])
  end
end

app/controllers/admin/orders/product_types_controller.rb
module Admin
  module Orders
    class ProductTypesController < AdminApp::ApplicationController
      helper Orders::Engine.helpers
      before_action :get_product_type, except: [:create, :index]

      def index
        @product_types = ProductType.order(category: :asc)
        if params[:view].nil?
          @product_types = @product_types.where(is_active: true)
        elsif params[:view] == 'inactive'
          @product_types = @product_types.where(is_active: false)
        end
      end

      def show
      end

      def update
        @product_type.update(product_type_params)
        if @product_type.valid?
          redirect_to admin_orders.product_type_url(@product_type, view: params[:view]), notice: "Product type was successfully updated."
        else
          render :show, status: :unprocessable_entity
        end
      end

      def create
        redirect_to ProductType.create!
      end

      private

      def product_type_params
        params.require(:product_type).permit(
          :type, :code, :title, :subtitle, :description, :category, :image, :region,
          :is_taxable, :quantity_type, :price, :value, :currency,
          :is_service, :is_active, :is_visible, :inventory, :is_shipping_required,
          :is_assignment_required, :distance_unit, :height, :width, :depth,
          :mass_unit, :weight, :front_matter, :end_matter, :specification,
          :shippable_to => []
        )
      end

      def get_product_type
        @product_type = ProductType.find params[:id]
      end
    end
  end
end

app/controllers/admin/orders/shipments_controller.rb
module Admin
  module Orders
    class ShipmentsController < AdminApplicationController
      optional_authentication
      optional_authorization

      def show
      end
    end
  end
end

app/controllers/orders/details_controller.rb
module Orders
  class DetailsController < ApplicationController
    optional_authentication
    optional_authorization
    layout 'center'
    def show
      @product_type = ProductType.find(params[:id])
    end
  end
end

app/controllers/orders/orders_controller.rb
module Orders
  class OrdersController < UserApp::ApplicationController
    optional_authentication
    optional_authorization
    before_action :check_permission

    helper Orders::Engine.helpers

    def index
      @orders = current_user.member.orders.order(created_at: :desc).page(params[:page])
    end

    def show
    end

    private

    # allow anonymous if using the encrypted code
    def check_permission
      if params[:id]
        @order = Order.find_by_encrypted_code(params[:id])
        if @order
          permit!
        else
          @order = Order.find_by_code(params[:id]) || Order.find(params[:id])
          permit! { @order.member&.user == current_user }
        end
      end
    end

  end
end

app/helpers/orders/location_helper.rb
module Orders
  module LocationHelper
    protected
    #
    # displays a list of ISO3166 alpha3 country codes
    # or alpha2 region codes in a localized way.
    #
    def display_location_codes(codes, separator: ', ')
      if codes.nil?
        I18n.t("Worldwide")
      else
        codes.map {|code|
          case code
            when "AF" then I18n.t("Africa")
            when "AN" then I18n.t("Antarctica")
            when "AS" then I18n.t("Asia")
            when "EU" then I18n.t("Europe")
            when "NA" then I18n.t("North America")
            when "OC" then I18n.t("Oceania")
            when "SA" then I18n.t("South America")
            else ISO3166::Country.find_country_by_alpha3(code)&.local_name
          end
        }.join(', ')
      end
    end

    #
    # options for places we might or might not ship to.
    #
    def ship_to_options
      countries = [
        ["United States", "USA"],
        ["Puerto Rico", "PRI"],
        ["Canada", "CAN"]
      ]
      continents = [
        [I18n.t("Africa"),        "AF"],
        [I18n.t("Antarctica"),    "AN"],
        [I18n.t("Asia"),          "AS"],
        [I18n.t("Europe"),        "EU"],
        [I18n.t("North America"), "NA"],
        [I18n.t("Oceania"),       "OC"],
        [I18n.t("South America"), "SA"]
      ]
      countries + continents
    end
  end
end

app/helpers/orders/order_helper.rb
module Orders::OrderHelper

  protected

  ORDER_STATE_BADGES = {
    "new"      => ["primary", "new"],
    "paid"     => ["success", "paid"],
    "pending"  => ["warning", "pending"],
    "error"    => ["danger", "error"],
    "canceled" => ["secondary", "canceled"],
    "refunded" => ["dark", "refunded"]
  }

  def order_badges(order)
    badges = []
    badge_state_class = "text-bg-" + ORDER_STATE_BADGES[order.state][0]
    badge_state_label = ORDER_STATE_BADGES[order.state][1]
    badges << content_tag(:span, class: 'badge rounded-pill ' + badge_state_class) { badge_state_label }
    if order.is_shipping_required?
      if order.is_fulfilled?
        badges << content_tag(:span, class: 'badge rounded-pill text-bg-success') { "shipped" }
      else
        badges << content_tag(:span, class: 'badge rounded-pill text-bg-secondary') { "not shipped" }
      end
    end
    safe_join(badges, ' ')
  end

end

app/views/admin/orders/orders/_contents.html.haml
%table.table.table-striped.table-bordered
  %tr
    %th Item
    %th Quantity
    %th Total
  - @order.order_lines.each do |line|
    %tr
      %td
        = line.title
        - if line.subtitle
          .help-text
            = line.subtitle
      %td= line.quantity
      %td= display_money line.amount
  %tr
    %td{colspan: 2} Tax
    %td= display_money @order.tax
  %tr
    %td{colspan: 2} Total
    %td= display_money @order.total

app/views/admin/orders/orders/_payments.html.haml
payments

app/views/admin/orders/orders/_shipping.html.haml
shipping

app/views/admin/orders/orders/index.html.haml
= breadcrumbs

.mb-3
  - path = {view: params[:view], filter: params[:filter]}
  = v.tab_bar do |bar|
    - bar.with_tab url: orders_path(path.merge(view: nil)),         label: 'All',      active: active(view: nil)
    - Order.states.keys.each do |view|
      - bar.with_tab url: orders_path(path.merge(view: view)),      label: view.capitalize,      active: active(view: view)

= paginate @orders

%table.table
  %tr
    %th Code
    %th Member
    %th Date
    %th.text-right Total
    %th
  - if !@orders.any?
    %tr
      %td{colspan: 5} No orders
  - else
    - @orders.each do |order|
      %tr
        %td= link_to order.code, order_path(order)
        %td= link_to (order.member&.name || "NONE"), order_path(order)
        %td= link_to order.created_at.to_date, order_path(order)
        %td= link_to display_money(order.total), order_path(order)
        %td.text-right= order_badges(order)
        -#%td
          - if order.is_shipping_required? && order.shipment.nil?
            = form_with(model: order, method: 'put') do
              %button.btn.btn-sm.btn-success{type: 'submit', name: 'command_ship_it', disabled: (!order.is_active? || !order.is_paid?)}
                = icon(:ship, "Ship")

= paginate @orders

app/views/admin/orders/orders/show.html.haml
= breadcrumbs { @order.code }

= mini_avatar_link(@order.member)
= v.header @order, right: order_badges(@order)

.mb-3
  = v.tab_bar do |bar|
    - bar.with_tab url: order_path(@order, view: nil), label: 'Contents', active: active(view: nil)
    - bar.with_tab url: order_path(@order, view: 'payments'), label: 'Payments', active: active(view: 'payments')
    - if @order.is_shipping_required?
      - bar.with_tab url: order_path(@order, view: 'shipping'), label: 'Shipping', active: active(view: 'shipping')

- if params[:view].nil?
  = render 'contents'
- elsif params[:view] == 'payments'
  = render 'payments'
- elsif params[:view] == 'shipping'
  = render 'shipping'